this.name        = "Fuel Collector"; 
this.author      = "Dennis Thony Pedersen (frame)"; 
this.copyright   = " 2008 the Oolite team."; 
this.description = "Device that collects fuel from wrecks & derelict ships"; 
this.version     = "0.1"; 

this.startUp = this.reset = function()
{

this.fuel_below01 = 0;
this.fuel_level_1 = 5
this.fuel_level_2 = 10
this.fuel_level_3 = 20
this.fuel_level_4 = 30
this.checkawardhowoften = 3
//this.myswitch = true
//this.myswitch1 = false
this.tonearsun = 290000
this.nearsun = 350000
this.averagesun = 450000
this.farfromsun = 520000
this.ispaceswitch = true
this.hacktime = 3
this.derelictcount = this.hacktime+1
this.derelictID = false
this.firstrun = true
this.mcounter = 0;
this.mmactive = false;
this.sustain = 3;
this.delay = 3;
this.leech = 0;
this.trapship = false;
this.trapcounter = 0;
this.planetlist = 0;
this.MainPlanetName = false;
//Sound.load("FCscoop.ogg")		//lets not use this for now, it would stop any playing music
//Sound.load("FCtrumblesqueal.ogg")	// Testing if two sounds could play at the same time, thats a negative
//this.tonearplanet = false // we do not need this as is set up entering or leaving planet/sun Vicinity



}

this.itsatrap = function() 
{
	if(this.trapship)
	{
		this.trapcounter ++
		player.consoleMessage("its going 2:"+this.trapship.shipDisplayName+":"+this.trapcounter,3)
		if(this.trapcounter > 3)
		{
			this.itsatrapTimer.stop()
			//player.consoleMessage("its going 3:"+this.trapship.shipDisplayName+":DEAD",3)
			this.trapcounter = 0
			this.trapship.explode()
			this.trapship.spawn("FCFrameSelfDestruct",1)
			//this.trapship = false
			return
		}
		return // we only get here in case of this.trapcounter<3
	}	
	else //ship died
	{
		this.itsatrapTimer.stop()
		this.trapcounter = 0
		this.trapship = false
		return
	}
	//we should never get here...
	log("Fuel Collector","Error Its a trap, we should never get here")
	
}

this.buildplanetlist = function()
{ //function very much in developing stages... 	
	if(system.planets.length == 1) //nutter might add planets in witchspace
	{
		this.MainPlanetName = system.name //+" 1" //used +1 one for testing...
		return //return from here, there is no more planets in the system
	}
	
	if(!system.sun)
	return;	//sanity check... no distance measurements to sun, or else we get errors...
		//number planets by posistion in the array... execpt main planet ofcourse
	
	//log("Fuel Collector","number of planets is "+system.planets.length)
	
	
	
	//function that sorts everything and gives every planet a name... only planets and suns
	//are dealt with, moons are not a consideration, im making this function now, so we can
	//use it in the future for giving planets names...
	this.planetlist = system.planets
	this.lp = system.planets.length
	//this.pllist[this.lp] //i want to declare it
	let pcounter = 0;
	
	for(pcounter = 0;pcounter<=this.lp;pcounter++)	//stuff name and distance everything into arrays
	{
		this.pllist[pcounter] = system.planets[pcounter].distanceTo(system.sun)
		this.plname[pcounter] = system.name + " "+pcounter+1 //add one cause we start at 0
		this.flname[pcounter] = "Planet" //for now just call it planet
	}
	//sort everything into so that the planet with the closest distance to the sun gets the destinction "1", next "2" and so on
		
}

	

this.self_destruct_countdown = function()
{
	//self destruct is allready initiated, all we need to check is if the
	//the ship is still alive...
	if(this.trapship)
	{
		this.trapship.setAI("dumbAI.plist")
		//player.consoleMessage("its going 1"+this.trapship.shipDisplayName,3)
		this.itsatrapTimer = new Timer(this, this.itsatrap,0,3)
	}
	//do nothing ship is dead...
}

this.consolemessage = function()
{
	if(player.docked)
	{ 
		this.consolemessageTimer.stop()
		return
	}
	
	this.mcounter ++
	if(this.mcounter < this.delay)
	return
	player.fuel += this.leech
	player.consoleMessage(this.mmessage, this.sustain)//player.energy -= 5
	this.consolemessageTimer.stop()
	this.mmactive = false
	this.mcounter = 0
	delete this.consolemessageTimer //remove so that we can set a new one with a new interval
}	

this.delayedmessage = function(message,delay,sustain)
{
	//his is a delayed message, it pops up on screen after n seconds = delay, and will stay there for n=sustain time
	if(this.mmactive)
	{
		log("Fuel Collector", "this.delayedmessage: Timer start before other is expired")
		return
	}
	
	this.mmessage = message	
	this.sustain = sustain
	this.delay = delay
	this.mmactive = true
	
	//start our timer....
	
	this.consolemessageTimer = new Timer(this, this.consolemessage,0,delay)
	
}

this.checkifover01 = function(fuel_award)
{	
	this.fuel_below01 += fuel_award	
	if(this.fuel_below01 > 1000)
	{
		
		player.fuel += 0.1
		//Sound.playMusic("FCscoop.ogg")
		//Sound.playMusic("FCtrumblesqueal.ogg")
		player.consoleMessage("Fuel Collector", 10)		
		player.consoleMessage("Gathered Fuel: 0.1 ly", 10)
		this.fuel_below01 -= 1000
	}
}

this.extractfuel = function()
{
	if(!player.hasEquipment("EQ_FRAME_FUEL_COLLECTOR") && !player.hasEquipment("EQ_FUEL_SCOOPS")) //checkup of both dependacies
	{		
		this.extractfuelTimer.stop()
		player.consoleMessage("Fuel collector",3)
		player.consoleMessage("Malfunction!!!",3)
		this.derelictID = false //set if we somehow mysteriously got it fixed
		return
	}
	
	if(player.docked)
	{ 
		this.extractfuelTimer.stop() //should not happen, but for safety reasons, there could in theory be a dereclict ship right outside the docking bay
		return
	}
	if(!this.derelictID || this.derelictID != player.target) //does ship exist, and is linked ship still the players target
	{
		player.consoleMessage("Fuel collector",3)
		player.consoleMessage("Lost link",3)
		this.extractfuelTimer.stop()
		//either way make sure that we dont enter a reoccuring loop
		this.derelictID = false
		return
	}
	else if(this.derelictID)
	{
		if(player.position.distanceTo(this.derelictID) > 300) //within range ?
		{
			this.extractfuelTimer.stop()
			player.consoleMessage("Fuel collector",3)
			player.consoleMessage("lost link to "+this.derelictID.shipDisplayName,3)
			if(this.derelictID.fuel > 0.09) //check if there is any fuel left in ships tanks
			this.derelictID = false	//if so set Id to false so we can connect to it again, next time we come in range
			return
		}
	}			
	
	if(this.derelictID.fuel > 0.09)	//extract fuel of any in the tank
	{
		this.derelictID.fuel -= 0.1
		//Sound.playMusic("FCscoop.ogg")
		//Sound.playMusic("FCtrumblesqueal.ogg")
		player.fuel += 0.1
		if(player.fuel == 7.0)	//are our tank full ?
		{
			player.consoleMessage("Fuel collector",3)
			player.consoleMessage("Tank full",3)			
			this.extractfuelTimer.stop()
			this.derelictID = false	//if so set Id to false so we can connect to it again, next time we come in range
			return
		}
		return // we check for empty tank next time
		
	}
	
	//if we made it here it means the victims fuel tank is empty
	player.consoleMessage("Fuel collector",3)
	player.consoleMessage(this.derelictID.shipDisplayName+"s Fuel Tank is Empty",3)	
	this.extractfuelTimer.stop()
	
}

	
	

this.DerelictCheck = function()
{
	if(!player.hasEquipment("EQ_FRAME_FUEL_COLLECTOR") && !player.hasEquipment("EQ_FUEL_SCOOPS")) //checkup of both dependacies
	{		
		this.DerelictCheckTimer.stop()
		if(!(this.derelictcount == this.hacktime+1))
		{
			player.consoleMessage("Fuel collector",3)
			player.consoleMessage("Malfunction!!!",3)
		}
		this.derelictcount == this.hacktime+1
			
		return
	}
	
		
		
	if(player.docked)
	{
		this.DerelictCheckTimer.stop() //should not happen, but for safety reasons, there could theory be a dereclict ship right outside the docking bay
		this.derelictcount = this.hacktime+1
		return
	}
	
	
	let a_derelict_ship = player.target
	
	if(!a_derelict_ship) //first check that there is a ship locked in players target computer
	{
		this.DerelictCheckTimer.stop()
		if(!(this.derelictcount == this.hacktime+1))
		{
			player.consoleMessage("Fuel collector",3)
			player.consoleMessage("Malfunction!!!",3)
		}
		this.derelictcount == this.hacktime+1
		
		return	//no active target return and stop timer... 
	}
	if(a_derelict_ship.AI != "nullAI.plist") //is this ship unpiloted, if so it could be derelict
	{
		this.DerelictCheckTimer.stop()
		this.derelictcount = this.hacktime+1
		player.consoleMessage("Fuel collector",3)
		player.consoleMessage("lost link",3)	
		return // not unpiloted(something must have happend)... stop timer
	}
	if(player.position.distanceTo(a_derelict_ship) > 300) //are we still within the 300 meters limit
	{
		this.DerelictCheckTimer.stop()
		this.derelictcount = this.hacktime+1
		player.consoleMessage("Fuel collector:Weak Signal",3)
		player.consoleMessage("Lost Link To "+a_derelict_ship.shipDisplayName, 3)
		return //we left the minimum distance... stop timer
	}
	//if(a_derelict_ship.isPirate || a_derelict_ship.isTrader || a_derelict_ship.hasRole("hunter") || a_derelict_ship.hasRole("shuttle") || a_derelict_ship.hasRole("miner") || a_derelict_ship.hasRole("escort"))	//legit derelict ship Traders & Pirates & Hunters
	if(a_derelict_ship.isPirate || a_derelict_ship.isTrader || a_derelict_ship.primaryRole == "hunter" || a_derelict_ship.primaryRole == "shuttle" || a_derelict_ship.primaryRole == "miner" || a_derelict_ship.primaryRole =="escort" || a_derelict_ship.primaryRole == "scavenger" || a_derelict_ship.primaryRole == "sunskim-trader")
	{
		//do stuff here
		this.derelictcount --
		player.consoleMessage("hacking:"+a_derelict_ship.shipDisplayName+" "+this.derelictcount, 1)
		if(this.derelictcount < 1)
		{
			let rab = Math.random()
			
			if(a_derelict_ship.fuel < 0.1)
			{
				player.consoleMessage("Fuel collector:ship has no fuel in Tank",3)
				this.derelictID = a_derelict_ship //mark as last ship connected to is empty
				
				if(a_derelict_ship.isPirate)//high odds for ship will self destruct...
				{
									
					if(rab<0.5)
					{
						player.consoleMessage("gonna go boom boom boom:pirate",3)
						this.trapship = a_derelict_ship
						this.self_destruct_countdown()
					}
					
						
					
					//run random boobytrap
					//we use a new timer that slowly but surely drains the ships energy bank //would be nice to alter recharge rate, but i guees that is not a possibility
				}
				else	//low odds for ship will have a bobbytrap
				{
					if(rab<0.05)
					{
						player.consoleMessage("gonna go boom boom boom:trader",3)
						this.trapship = a_derelict_ship
						this.self_destruct_countdown()
					}
				}								
				
				this.derelictcount = this.hacktime+1
				this.DerelictCheckTimer.stop()
				return
			}
			else
			{
				if(a_derelict_ship.isPirate && rab <0.5) //high odds
				{
					player.consoleMessage("gonna go boom boom boom:pirate",3)
					this.trapship = a_derelict_ship
					this.self_destruct_countdown()
				}
				else if(rab<0.05)
				{
					player.consoleMessage("gonna go boom boom boom:trader",3)
					this.trapship = a_derelict_ship
					this.self_destruct_countdown()
				}	
								
				this.derelictcount = this.hacktime+1
				player.consoleMessage("Extracting fuel",3)
				this.derelictID = a_derelict_ship				
				this.extractfuelTimer = new Timer(this,this.extractfuel,0,1) //tip dont use an arguement when you start a timer like this,this.mytimer(arguement) it will make a CTD			
				this.DerelictCheckTimer.stop()
				return // return because we dont need more checking from here...
			}			
		}
		
	}
	else	//no legit roles return and stop timer
	{		
		this.DerelictCheckTimer.stop()
		this.derelictcount = this.hacktime+1
		player.consoleMessage("Fuel collector",3) //we might have changed targets....
		player.consoleMessage("Lost Link ", 3)
		return //no legit roles
	}	
		
}

this.CruiseCheck = function()
{
	if(player.docked)
	{
		this.CruiseCheckTimer.stop()
		return // return because we really dont need more checking from here
			//return also saves a few cycles, instead of having the CPU do 3 extra Compares it just jumps to an address in memory
	}
	
	if(this.tonearplanet)
	return
		
	if(!player.hasEquipment("EQ_FRAME_FUEL_COLLECTOR") && !player.hasEquipment("EQ_FUEL_SCOOPS")) //is EQ damaged ?
	{
		this.CruiseCheckTimer.stop()
		return // return because we really dont need more checking from here
	}
	
    	
	//player.consoleMessage("entering cruisecheck", 3) // for testing
	if((player.speed > player.maxSpeed) || ( 7 == player.fuel)) //|| means explicit or // injector or warp speed
	{
		return // return because we really dont need more checking from here
	}
		
	//if(system.isInterstellarSpace) //some person in the future might add a sun in interstellar space
	if(!system.sun)
			//so if there is a sun present, it will activate the crusing mode collector	
	{
		if(this.ispaceswitch && this.firstrun)
		{
			this.ispaceswitch = false
			this.firstrun = false
			player.consoleMessage("Fuel Collector",3)
			player.consoleMessage("Interstellar Space:Fly at max speed to extract fuel",3)
			
		}
		
		//if there is not a sun there it will extract whatever it can from its surroundings...
		//however only as long as the player is at max speed..
		if(player.speed == player.maxSpeed)		
		this.checkifover01(this.fuel_level_1*Math.random())
		return  
		
	}
	else 
	{		
		//what distance are we at to the star
		// to close and it will shutdown, to far away it will collect very little
		
		/* a notice on why it shuts down, when to close
		
		due to the fine filter of the fuel collector, it will shut down when it
		gets to close to the star so that the filter is having a chance of getting
		cleaned by the subsequent cleaning, which in effect harvest the fuel from
		the filter
		
		The fuel scoop will then take over shortly after...
		*/
		
		
		let sun_distance = player.position.distanceTo(system.sun)+system.sun.radius	
		/* This is the old shut off if to close to sun...
		// this however didnt take into consideration, the proximity to the planet
		if(sun_distance <this.tonearsun) // to close
		{
			
			if(this.myswitch)
			{
				player.consoleMessage("Fuel Collector Deactivated",3)
				player.consoleMessage("To Close to Sun",3)
				this.myswitch = false;
				this.myswitch1 = true;
			}
			
			return //dont bother checking from here...
		}
		
		else if(this.myswitch1)//activate fuel collector
		{
			player.consoleMessage("Fuel Collector Activated",3)
			this.myswitch1 = false
			this.myswitch = true
			
		}
		*/		
		
		let distancemodifier =10
				
		if(sun_distance< this.averagesun)
		distancemodifier = 30
		if(sun_distance< this.nearsun)
		distancemodifier = 50 //this is near the filters saturation limit,...
				
		let speedp = 100/player.maxSpeed*player.speed
		
		if(speedp>89)
		{
			this.checkifover01(this.fuel_level_4+distancemodifier)			
		//	player.consoleMessage("speed over 89 %", 3) // for testing
			return			
		}
		
		if(speedp>49)
		{
			this.checkifover01(this.fuel_level_3+distancemodifier)
		//	player.consoleMessage("speed over 49 %",3) // for testing
			return			
		}
		
		if(speedp>19)
		{
			this.checkifover01(this.fuel_level_2+distancemodifier)
		//	player.consoleMessage("speed over 19 %",3) // for testing
			return			
		}		
	}
}

this.killCheck = function()
{
	//while this is no more the function that awards fuel after a kill, it still does valueble checkups
	       
    	if(player.docked)
    	{
    		this.KillCheckTimer.stop()
    		return
    	}
    	
    	else
    	{
    		if(player.fuel < 7 && player.speed <= player.maxSpeed) //if players tank is full, no need to check, dont work at injector or warp speed
    		{
    			
    			
    			let pl_target = player.target			
    				
    			
    			//derelict ship section.   			
    			   			
    			
    			if(pl_target && (this.derelictcount == this.hacktime+1)) //11 means our timer has not yet started, lets save some cpu cycles
    			{
    				let target_ship_AI = pl_target.AI
    				if(target_ship_AI == "nullAI.plist" && this.derelictID != pl_target)	//derelict ships have nullAI.plist, ID means this is the last ship that has been linked too we either emptied its tanks, or it was empty
    				{
    					//player.consoleMessage("got NULLAI:"+pl_target.primaryRole, 3)
    					this.derelictID = false
    					if(player.position.distanceTo(pl_target) < 301)
    					{
    						//log("Fuel Collector", "distance below 301")
    						//if(pl_target.isPirate || pl_target.isTrader || pl_target.hasRole("hunter") && !this.DerelictCheckTimer)
    						if(pl_target.isPirate || pl_target.isTrader || pl_target.primaryRole == "hunter" || pl_target.primaryRole == "shuttle" || pl_target.primaryRole == "miner" || pl_target.primaryRole =="escort" || pl_target.primaryRole == "scavenger" || pl_target.primaryRole == "sunskim-trader" && !this.DerelictCheckTimer)	//legit derelict ship Traders & Pirates & Hunters
    						{    							
    							//log("Fuel Collector", "got role")
    							if(this.DerelictCheckTimer)
    							this.DerelictCheckTimer.start()
    							else
    							{
    								this.DerelictCheckTimer = new Timer(this,this.DerelictCheck,0,1) //tip dont use an arguement when you start a timer like this,this.mytimer(arguement) it will make a CTD
    								player.consoleMessage("Fuel Collector", 3)
    								player.consoleMessage("Established Link To"+pl_target.shipDisplayName, 3)
    							}
    							
    							
    						}
    						
    					}
    					
    				}
    			}
    		}
    		
    	}
    	      
        //check if Equipment has been damaged during battle...
        if(!player.hasEquipment("EQ_FRAME_FUEL_COLLECTOR") && !player.hasEquipment("EQ_FUEL_SCOOPS")) //checkup of both dependacies
        this.KillCheckTimer.stop()
}


this.shipLaunchedFromStation = function() //script starts here after startup borrowed from bouy repair great work Erich ;)
{
	//this.myswitch = true	//just in case there is a station inside the tonear zone
	//this.myswitch1 = false
	this.buildplanetlist();
	this.ispaceswitch = true
	
		if(player.hasEquipment("EQ_FRAME_FUEL_COLLECTOR") && player.hasEquipment("EQ_FUEL_SCOOPS")) //checkup of both dependacies
	{
		if(this.KillCheckTimer)
		this.KillCheckTimer.start()
		else
		this.KillCheckTimer = new Timer(this, this.killCheck,0,3)
		
		if(this.CruiseCheckTimer)
		this.CruiseCheckTimer.start()
		else
		this.CruiseCheckTimer = new Timer(this,this.CruiseCheck,0,this.checkawardhowoften)
	}
        
}

this.shipExitedWitchspace = function() //script starts here once player jumps to a new system
{
	// reset our switches player can have witched out, well within the tonear zone
	this.buildplanetlist();
		this.ispaceswitch = true
	
	
	if(player.hasEquipment("EQ_FRAME_FUEL_COLLECTOR") && player.hasEquipment("EQ_FUEL_SCOOPS")) //checkup of both dependaciesif(player.hasEquipment("EQ_FRAME_FUEL_COLLECTOR"))
	{
		if(this.KillCheckTimer)
		this.KillCheckTimer.start()
		else
		this.KillCheckTimer = new Timer(this, this.killCheck,0,3)
		  
		if(this.CruiseCheckTimer)
		this.CruiseCheckTimer.start()
		else
		this.CruiseCheckTimer = new Timer(this,this.CruiseCheck,0,this.checkawardhowoften)
	}
	
}

this.shipDied = function()
{
	//player.consoleMessage("player died",10)
	if(this.KillCheckTimer)
	this.KillCheckTimer.stop()
	this.CruiseCheckTimer.stop()
	if(this.consolemessageTimer)
	this.consolemessageTimer.stop()
	if(this.extractfuelTimer)
	this.extractfuelTimer.stop()
	if(this.itsatrapTimer)
	this.itsatrapTimer.stop()
}

this.shipDestroyedTarget = function(target)
{
	//could no
	if(!player.hasEquipment("EQ_FRAME_FUEL_COLLECTOR") && !player.hasEquipment("EQ_FUEL_SCOOPS"))
	return
	
	if((target.fuel > 0.09) && (player.position.distanceTo(target) < 2000) && !(player.speed > player.maxSpeed) && !target.isThargoid)
	{
		let leech = target.fuel
		let leech2 = target.fuel/0.1
		//let ra = Math.random()	//percentage
		//leech = target.fuel*ra // random percetange to start with
		let ra=Math.random()
		if(ra>0.3)
		leech=leech2*0.1*0.015 //roughtly 0.1 lyof 7 ly
		if(ra<=0.3)
		leech=leech2*0.2*0.030 //award only 5%
		if(ra<0.1)
		leech=leech2*0.5*0.060 //award 10%
    					
		//roundoff
		leech = Math.round(leech/0.1)*0.1		    					 					   					
		
		if(leech >0) //only award if victim actually had any fuel left...
		{
			let ourmessage = "Fuel:"+leech+" LY"
			player.fuel += leech
			
			//Sound.playMusic("FCscoop.ogg")
			//Sound.playMusic("FCtrumblesqueal.ogg")
			this.delayedmessage(ourmessage,3,3) //lets avoid all the message garble when getting a kill
		}
	}
}

this.shipExitedPlanetaryVicinity = function()
{
	player.consoleMessage("Fuel Collector Activated",3)
	this.tonearplanet = false
}

this.shipEnteredPlanetaryVicinity = function(planet)
{
	//let sun_distance = player.position.distanceTo(system.sun)+system.sun.radius
	let entityname = "planet"	//im thinking it would be nice if we could add a number
	if(planet.isMainPlanet)//let planet_distance = player.posistion.distanceTo(
	entityname = this.MainPlanetName
	if (planet.isSun)//this is so odd ehh, but it works, as planet is an entity
	entityname = system.name + "s sun"
	
	player.consoleMessage("Fuel Collector Deactivated",3)
	player.consoleMessage("To Close to "+entityname,3)
	this.tonearplanet = true
}





    			
    				
		



	
	

	





	
